package roneditor;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.FontData;

/**
 * Some constants and identifiers used across all components of the RONEditor.
 */
public interface IRonEditorConstants {

	/**
	 * This is the ID of the View for object nets according to <code>plugin.xml</code>.
	 */
	public static String objectNetViewID = "roneditor.ui.views.ObjectNetPageBookView";

	/**
	 * This is the ID of the View for rules according to <code>plugin.xml</code>.
	 */
	public static String ruleViewID = "roneditor.ui.views.RulePageBookView";
									   

	/**
	 * This is the ID of the View for ron according to <code>plugin.xml</code>.
	 */
	public static String ronViewID = "roneditor.ui.views.RONPageBookView";
	
	/**
	 * A shared {@link FontData} object for a 14 pt bold Sans font.
	 */
	public static FontData[] objectNetFontData = new FontData[] { new FontData("Sans", 14, SWT.BOLD) };

	/**
	 * An identifier for the shared 14 pt bold Sans font.
	 */
	public static String objectNetFontID = "Sans14Bold";
}
