package roneditor.gef.actions;

import org.eclipse.gef.DefaultEditDomain;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.ISelectionProvider;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.actions.RetargetAction;

import roneditor.IRonEditorConstants;
import roneditor.model.IDUtil;
import roneditor.ui.part.RONTreeEditor;
import roneditor.ui.part.AbstractTreeEditor.EditorTreeViewer;
import ronmodel.RON;

public class OpenRonAction extends RetargetAction {

	public static final String ID = "roneditor.actions.OpenRonAction";
	
	RON ron;
	ISelectionProvider provider;
	
	public OpenRonAction(IWorkbenchPage p, ISelectionProvider selectionProvider){
		super(ID,"open");
		provider = selectionProvider;
	}
	
	public boolean isEnabled(){
		ISelection selection = provider.getSelection();
		if (!selection.isEmpty()) {
			IStructuredSelection sSelection = (IStructuredSelection) selection;
			if(sSelection.size() == 1 && 
					sSelection.getFirstElement() instanceof RON){
				ron = (RON)sSelection.getFirstElement();
				return true;
			}
		}
		return false;
	}
	
	public void run(){
	
		
		final IWorkbenchPage activePage = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
		// Use URI of the model as secondaryID to enable the view to access the
		// model
		try {
		activePage.showView(IRonEditorConstants.ronViewID, IDUtil
				.createIDForModel(ron), IWorkbenchPage.VIEW_ACTIVATE);
		} catch (final PartInitException e) {
//			final String message = "View with ID " + IRonEditorConstants.ronViewID
//				+ " could not be initialied in RONTreeEditPart.";
//		((RONTreeEditor) ((DefaultEditDomain) getViewer().getEditDomain()).getEditorPart()).logError(message, e);
		}
	}
}
