package roneditor.gef.actions.rule;

import org.eclipse.ui.IEditorPart;

import roneditor.ui.part.RulePage;
import ronmodel.LHS;
import ronmodel.NAC;

/**
 * Copies the object net in the {@link LHS} to the active {@link NAC} given a
 * {@link RulePage}.
 */
public class CopyLHSToNACAction extends ObjectnetCopyAction {

	static public final String ID = "Copy LHS -> NAC";

	static public final String TEXT = "Copy LHS -> NAC";

	static public final String TOOL_TIP_TEXT = "Copies the object net in the LHS to the active NAC";

	public CopyLHSToNACAction(RulePage rulePage, IEditorPart editor) {
		super(editor, rulePage);
		setId(ID);
		super.setText(TEXT);
		super.setDescription(TEXT);
		super.setToolTipText(TOOL_TIP_TEXT);
	}

	@Override
	public void update() {
		setTarget(getRulePage().getActiveNAC());
		setSource(getRulePage().getRule().getLhs());
		super.update();
	}
}
