package roneditor.gef.actions.rule;

import org.eclipse.ui.IEditorPart;

import roneditor.ui.part.RulePage;
import ronmodel.LHS;
import ronmodel.RHS;

/**
 * Copies the object net in the {@link LHS} to the {@link RHS} given a
 * {@link RulePage}.
 */
public class CopyLHSToRHSAction extends ObjectnetCopyAction {

	static public final String ID = "Copy LHS -> RHS";

	static public final String TEXT = "Copy LHS -> RHS";

	static public final String TOOL_TIP_TEXT = "Copies the object net in the LHS to the RHS";

	public CopyLHSToRHSAction(RulePage rulePage, IEditorPart editor) {
		super(editor, rulePage);
		super.setId(ID);
		super.setText(TEXT);
		super.setDescription(TEXT);
		super.setToolTipText(TOOL_TIP_TEXT);
	}

	@Override
	public void update() {
		setTarget(getRulePage().getRule().getRhs());
		setSource(getRulePage().getRule().getLhs());
		super.update();
	}

}
