package roneditor.gef.actions.rule;

import org.eclipse.gef.ui.actions.WorkbenchPartAction;
import org.eclipse.ui.IEditorPart;

import roneditor.gef.commands.ron.CreateNACCommand;
import roneditor.ui.part.RulePage;
import ronmodel.NAC;
import ronmodel.Rule;

/**
 * Create a new {@link NAC} given a {@link RulePage}.
 */
public class CreateNACAction extends WorkbenchPartAction {
	static public final String ID = "CreateNACAction";

	static public final String TEXT = "Create empty NAC";

	static public final String TOOL_TIP_TEXT = "Create an empty NAC for the active Rule";

	private RulePage rulePage;

	public CreateNACAction(final RulePage rulePage, IEditorPart editor) {
		super(editor);
		this.rulePage = rulePage;
		setId(ID);
		setText(TEXT);
		setDescription(TEXT);
		setToolTipText(TOOL_TIP_TEXT);
	}

	@Override
	public void run() {
		final Rule rule = rulePage.getRule();
		CreateNACCommand command = new CreateNACCommand(rule);
		execute(command);
		rulePage.setActiveNAC(command.getNac());
	}

	@Override
	protected boolean calculateEnabled() {
		return rulePage.getRule() != null;
	}
}
