package roneditor.gef.actions.rule;

import org.eclipse.gef.ui.actions.WorkbenchPartAction;
import org.eclipse.ui.IEditorPart;

import roneditor.gef.commands.ron.DeleteNACCommand;
import roneditor.ui.part.RulePage;
import ronmodel.NAC;

/**
 * Action for deleting a {@link NAC} given a {@link RulePage}
 */
public class DeleteNACAction extends WorkbenchPartAction {
	static public final String ID = "DeleteNACAction";

	static public final String TEXT = "Delete NAC";

	static public final String TOOL_TIP_TEXT = "Delete the active NAC from the active Rule";

	private RulePage rulePage;

	public DeleteNACAction(final RulePage rulePage, IEditorPart editor) {
		super(editor);
		this.rulePage = rulePage;
		setId(ID);
		setText(TEXT);
		setDescription(TEXT);
		setToolTipText(TOOL_TIP_TEXT);
	}

	@Override
	public void run() {
		NAC nac = rulePage.getActiveNAC();
		execute(new DeleteNACCommand(nac));
		rulePage.setNextNAC();
	}

	@Override
	protected boolean calculateEnabled() {
		return (rulePage.getActiveNAC() != null);
	}

}
