package roneditor.gef.actions.rule;

import org.eclipse.jface.action.Action;

import roneditor.ui.part.RulePage;
import ronmodel.NAC;

/**
 * This action is used by a {@link RulePage} and switches the {@link NAC} that is shown
 * in the first viewer.
 */
public class SwitchNACAction extends Action {
	static public final String ID = "SwitchNACAction";

	static public final String TEXT = "Switch NAC";

	static public final String TOOL_TIP_TEXT = "Cycle through all NACs of the active Rule";
	
	private RulePage rulePage;

	public SwitchNACAction(final RulePage rulePage) {
		this.rulePage = rulePage;
		setId(ID);
		setText(TEXT);
		setDescription(TEXT);
		setToolTipText(TOOL_TIP_TEXT);
	}

	@Override
	public void run() {
		rulePage.setNextNAC();
	}
	
	/**
	 * This action is only enabled for pages showing rules with at least 2 NACs.
	 */
	@Override
	public boolean isEnabled() {
		return rulePage.getRule().getNacs().size() > 1;
	}
}
