package roneditor.gef.commands.objectnet;

import org.eclipse.gef.commands.Command;

import ronmodel.ONNode;
import ronmodel.ObjectNet;

/**
 * Command for creating a generic node
 * 
 */
public class CreateNodeCommand extends Command {
	protected ONNode onNode;

	protected int x;

	protected int y;

	protected ObjectNet network;

	protected String name = "";

	/**
	 * Constructor
	 */
	public CreateNodeCommand() {
		super();
	}

	/**
	 * Entry point for command execution.
	 */
	public void execute() {
		onNode.setName(name);
		onNode.setObjectNet(network);
		onNode.setX(x);
		onNode.setY(y);
	}

	/**
	 * Redo command execution.
	 */
	public void redo() {
		onNode.setObjectNet(network);
	}

	/**
	 * Undo command execution.
	 */
	public void undo() {
		onNode.setObjectNet(null);
	}

	/**
	 * @return the onplace
	 */
	public ONNode getONNode() {
		return onNode;
	}

	/**
	 * @param node
	 *            the onplace to set
	 */
	public void setONNode(ONNode node) {
		this.onNode = node;
	}

	/**
	 * @return the network
	 */
	public ObjectNet getObjectNet() {
		return network;
	}

	/**
	 * @param network
	 *            the network to set
	 */
	public void setObjectNet(ObjectNet network) {
		this.network = network;
	}

	/**
	 * @return the x
	 */
	public int getX() {
		return x;
	}

	/**
	 * @param x
	 *            the x to set
	 */
	public void setX(int x) {
		this.x = x;
	}

	/**
	 * @return the y
	 */
	public int getY() {
		return y;
	}

	/**
	 * @param y
	 *            the y to set
	 */
	public void setY(int y) {
		this.y = y;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name
	 *            the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

}
