package roneditor.gef.commands.objectnet;

import ronmodel.ONPlace;

/**
 * Command for creating a place.
 */
public class CreatePlaceCommand extends CreateNodeCommand {
	int capacity;

	/**
	 * Entry point for command execution.
	 */
	public void execute() {
		super.execute();
		((ONPlace) onNode).setCapacity(capacity);
	}

	/**
	 * Set the initial capacity for the place.
	 * 
	 * @param capacity
	 *            the initial capacity
	 */
	public void setCapacity(int capacity) {
		this.capacity = capacity;
	}

	/**
	 * Get the initial capacity for the place.
	 * 
	 * @return capacity
	 */
	public int getCapacity() {
		return capacity;
	}
}
