package roneditor.gef.commands.objectnet;

import java.util.Collection;

import org.eclipse.gef.commands.Command;

import roneditor.clipboard.ClipboardUtil;
import ronmodel.ObjectNet;

/**
 * This command will paste a part of an objectnet (which is given as serialized String)
 * into another objectnet
 * @author choeger
 *
 */
public class PasteObjectNetCommand extends Command {

	private ObjectNet target;
	private String clipString;
	private Collection pasted;
	
	public PasteObjectNetCommand(String objectNet, ObjectNet target) {
		this.target = target;
		clipString = objectNet;
		pasted = null;
	}

	/**
	 * paste it!
	 */
	public void execute()
	{
		pasted = ClipboardUtil.pasteElementsFromString(clipString, target, null, null);
	}
	
	/**
	 * remove the collection
	 */
	public void undo()
	{
		target.getNodes().removeAll(pasted);
		target.getArcs().removeAll(pasted);
	}
	
	/**
	 * paste it again!
	 */
	public void redo()
	{
		pasted =  ClipboardUtil.pasteElementsFromString(clipString, target, null, null);
	}

	public boolean canExecute()
	{	
		return true;
	}
}

