/**
 * 
 */
package roneditor.gef.commands.ron;

import java.util.List;

import org.eclipse.gef.commands.CompoundCommand;

import roneditor.gef.commands.rule.ApplyRuleCommand;
import ronmodel.HLPlace;
import ronmodel.HLPlaceType;
import ronmodel.ObjectNet;
import ronmodel.Token;

/**
 * {@link CompoundCommand} for {@link ApplyRuleCommand}, takes two {@link HLPlace},
 * one has to be of type <code>NET</code> and the other of type <code>RULE</code> and executes for each on the
 * place {@link ObjectNet} all rules of the other place.
 */
public class ApplyRulesCommand extends CompoundCommand {

	public static final String LABEL = "ApplyRulesCommand";

	HLPlace objectnetPlace;

	HLPlace rulePlace;

	@SuppressWarnings("unchecked")
	public ApplyRulesCommand(HLPlace place1, HLPlace place2) {

		// choose the right order
		if ( place1.getType().equals(HLPlaceType.NET_LITERAL) && place2.getType().equals(HLPlaceType.RULE_LITERAL) ) {
			objectnetPlace = place1;
			rulePlace = place2;
		}
		else if ( place2.getType().equals(HLPlaceType.NET_LITERAL) && place1.getType().equals(HLPlaceType.RULE_LITERAL) ) {
			objectnetPlace = place2;
			rulePlace = place1;
		}
		else 
			return;
		
		List<Token> objectnets = objectnetPlace.getTokens();
		List<Token> rules = rulePlace.getTokens();
		for (Token objectnet : objectnets) {
			for (Token rule : rules) {
				add(new ApplyRuleCommand(objectnet, rule));
			}
		}
	}

}
