package roneditor.gef.commands.ron;

import java.util.Collection;

import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gef.commands.Command;

import ronmodel.HLPlace;
import ronmodel.ObjectNet;
import ronmodel.Token;

/**
 * helper class that copies one {@link ObjectNet} from
 * a {@link HLPlace} to <i>one</i> new {@link ObjectNet}
 * on the target {@link HLPlace}.
 */
public class CopyTokenToHLPlaceCommand extends Command {
	HLPlace target;

	Token targetToken;

	Collection allTokenContent = null;
	Token source = null;
	
	@SuppressWarnings("unchecked")
	public CopyTokenToHLPlaceCommand(Token source, HLPlace target) {
		this.target = target;
		this.source =  source;

	}
	
	@Override
	public void execute() {
		targetToken = (Token) EcoreUtil.copy(source);
		targetToken.setName(source.getName());
		targetToken.setPlace(target);
	}

	public void undo() {
		targetToken.setPlace(null);
	}

	public void redo() {
		targetToken.setPlace(target);
	}

}
