package roneditor.gef.commands.ron;

import org.eclipse.gef.commands.Command;

import ronmodel.HLNode;
import ronmodel.ONPlace;
import ronmodel.RON;

/**
 * Command for creating a generic node
 * 
 */
public class CreateHLNodeCommand extends Command {
	protected HLNode hlNode;

	protected int x;

	protected int y;

	protected RON ron;

	protected String name = "";

	/**
	 * Constructor
	 */
	public CreateHLNodeCommand() {
		super();
	}

	/**
	 * Entry point for command execution.
	 */
	public void execute() {
		hlNode.setName(name);
		hlNode.setRon(ron);
		hlNode.setX(x);
		hlNode.setY(y);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#canExecute()
	 */
	@Override
	public boolean canExecute() {
		return name != null;
	}
	
	/**
	 * Redo command execution.
	 */
	public void redo() {
		hlNode.setRon(ron);
	}

	/**
	 * Undo command execution.
	 */
	public void undo() {
		hlNode.setRon(null);
	}

	/**
	 * @return the {@link ONPlace}
	 */
	public HLNode getHLNode() {
		return hlNode;
	}

	/**
	 * @param node
	 *            the {@link ONPlace} to set
	 */
	public void setHLNode(HLNode node) {
		this.hlNode = node;
	}

	/**
	 * @return the network
	 */
	public RON getRON() {
		return ron;
	}

	/**
	 * @param ron
	 *            the {@link RON} to set
	 */
	public void setRON(RON ron) {
		this.ron = ron;
	}

	/**
	 * @return the x
	 */
	public int getX() {
		return x;
	}

	/**
	 * @param x
	 *            the x to set
	 */
	public void setX(int x) {
		this.x = x;
	}

	/**
	 * @return the y
	 */
	public int getY() {
		return y;
	}

	/**
	 * @param y
	 *            the y to set
	 */
	public void setY(int y) {
		this.y = y;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name
	 *            the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

}
