package roneditor.gef.commands.ron;

import ronmodel.HLPlace;
import ronmodel.HLPlaceType;
import ronmodel.RON;

/**
 * Command for adding a HLPlace to a RON. This is undoable.
 */
public class CreateHLPlaceCommand extends CreateHLNodeCommand {

	private HLPlaceType type;

	public CreateHLPlaceCommand(){
		super();
	}
	
	public CreateHLPlaceCommand(final RON ron, final HLPlace place) {
		super();
		this.ron = ron;
		this.hlNode = place;
	}

	/**
	 * Executes the command by adding the HLPlace to the RON.
	 * 
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	@Override
	public void execute() {
		super.execute();
		((HLPlace)hlNode).setType(type);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#canExecute()
	 */
	@Override
	public boolean canExecute() {
		return name != null && type != null;
	}

	/**
	 * @param type
	 *            the type to set
	 */
	public void setType(final HLPlaceType type) {
		this.type = type;
	}
}
