package roneditor.gef.commands.ron;

import ronmodel.HLTransition;
import ronmodel.HLTransitionKind;

/**
 * Command for creating a transition.
 */
public class CreateHLTransitionCommand extends CreateHLNodeCommand {

	HLTransitionKind kind;

	/**
	 * Constructor.
	 */
	public CreateHLTransitionCommand() {
		super();
	}

	/**
	 * Executes the command by adding the HLTransition to the RON.
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	@Override
	public void execute() {
		super.execute();
		((HLTransition) hlNode).setKind(kind);
	}

	/**
	 * @param type
	 *            the type to set
	 */
	public void setKind(final HLTransitionKind kind) {
		this.kind = kind;
	}
}
