package roneditor.gef.commands.ron;

import org.eclipse.gef.commands.Command;

import ronmodel.HLPlace;
import ronmodel.Token;

/**
 * helper class that moves an {@link Token} to the given {@link HLPlace} without further checks
 */
public class MoveTokenToHLPlaceCommand extends Command {
	Token token;

	HLPlace target;

	HLPlace oldPlace;

	int oldPosition;
	
	public MoveTokenToHLPlaceCommand(Token token, HLPlace target) {
		this.token = token;
		this.target = target;
		this.oldPlace = token.getPlace();
		this.oldPosition = oldPlace.getTokens().indexOf(token);
	}

	@Override
	public void execute() {
		token.setPlace(target);
	}

	public void undo() {
		token.setPlace(oldPlace);
		int currentPosition = oldPlace.getTokens().indexOf(token);
		oldPlace.getTokens().move(oldPosition, currentPosition);
	}

	@Override
	public void redo() {
		execute();
	}
}
