package roneditor.gef.commands.ron;

import java.util.Collection;

import org.eclipse.gef.commands.Command;

import roneditor.clipboard.ClipboardUtil;
import ronmodel.RON;

/**
 * This command will paste a HLPLace or HLRule (which is given as serialized
 * String) into a {@link RON}
 * 
 * @author choeger
 * 
 */
public class PasteHLModelCommand extends Command {

	private RON target;
	private String clipString;
	private Collection pasted;

	public PasteHLModelCommand(String model, RON target) {
		this.target = target;
		clipString = model;
		pasted = null;
	}

	/**
	 * paste it!
	 */
	public void execute() {
		pasted = ClipboardUtil.pasteElementsFromString(clipString, target,
				null, null);
	}

	/**
	 * remove the collection
	 */
	@SuppressWarnings("unchecked")
	public void undo() {
		target.getNodes().removeAll(pasted);
		target.getArcs().removeAll(pasted);
	}

	/**
	 * paste it again!
	 */
	public void redo() {
		pasted = ClipboardUtil.pasteElementsFromString(clipString, target,
				null, null);
	}

	public boolean canExecute() {
		return true;
	}
}
