package roneditor.gef.commands.ron;

import java.util.Collection;

import org.eclipse.gef.commands.Command;

import roneditor.clipboard.ClipboardUtil;
import ronmodel.HLPlace;

/**
 * This command will paste a Token (which is given as serialized String) into a
 * HLPlace
 * 
 * @author choeger
 * 
 */
public class PasteTokenCommand extends Command {

	private HLPlace target;
	private String clipString;
	private Collection pasted;

	public PasteTokenCommand(String model, HLPlace target) {
		this.target = target;
		clipString = model;
		pasted = null;
	}

	/**
	 * paste it!
	 */
	public void execute() {
		pasted = ClipboardUtil.pasteElementsFromString(clipString, target,
				null, null);
	}

	/**
	 * remove the collection
	 */
	public void undo() {
		target.getTokens().removeAll(pasted);
	}

	/**
	 * paste it again!
	 */
	public void redo() {
		pasted = ClipboardUtil.pasteElementsFromString(clipString, target,
				null, null);
	}

	public boolean canExecute() {
		return true;
	}
}