package roneditor.gef.editparts.ron;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.swt.widgets.Shell;

import ronmodel.HLArc;
import ronmodel.HLPlace;
import ronmodel.HLTransition;
import ronmodel.RON;
import ronmodel.Token;

/**
 * Factory class for graphical edit parts. Here, the corresponding edit parts of
 * a network are created.
 */
public class RONEditPartFactory implements EditPartFactory {
	
	
	public RONEditPartFactory() {
		super();
	}

	public RONEditPartFactory(Shell shell) {
		super();
	}

	/**
	 * Create an instance of the requested EditPart in the given context.
	 * Register the eAdapters of the Model in the rulePage if applicable.
	 * 
	 * @param context
	 *            The context
	 * @param obj
	 *            The type from the model to create the EditPart for
	 * 
	 * @see org.eclipse.gef.EditPartFactory#createEditPart(org.eclipse.gef.EditPart,
	 *      java.lang.Object)
	 */
	@SuppressWarnings("unchecked")
	public EditPart createEditPart(EditPart context, Object obj) {
		if (obj instanceof RON) {
			RONEditPart p = new RONEditPart((RON) obj);
			return p;
		} else if (obj instanceof HLPlace) {
			HLPlaceEditPart p = new HLPlaceEditPart((HLPlace) obj);
			return p;
		} else if (obj instanceof HLTransition) {
			HLTransitionEditPart p = new HLTransitionEditPart((HLTransition) obj);
			return p;
		} else if (obj instanceof HLArc) {
			HLArcEditPart p = new HLArcEditPart((HLArc) obj);
			return p;
		} else if (obj instanceof Token) {
			SimpleTokenEditPart p = new SimpleTokenEditPart((Token) obj);
			return p;
		}
		
		
		return null;
	}
}
