package roneditor.gef.editparts.tree;

import org.eclipse.core.runtime.Assert;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;

import roneditor.gef.editparts.ron.HLNodeEditPart;
import ronmodel.HLPlace;
import ronmodel.HLTransition;
import ronmodel.ObjectNet;
import ronmodel.RON;
import ronmodel.Rule;

/**
 * Factory class for tree edit parts. Here, the corresponding edit parts of a
 * the model elements are created.
 * 
 * @author Tony Modica
 */
public class RONTreeEditPartFactory implements EditPartFactory {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.EditPartFactory#createEditPart(org.eclipse.gef.EditPart,
	 *      java.lang.Object)
	 */
	public EditPart createEditPart(final EditPart context, final Object obj) {
		// HINT Passt diese Methode an Euer Modell und Eure TreeEditParts an
		if (obj instanceof RON) {
			return new RONTreeEditPart(obj);
		} else if (obj instanceof HLPlace) {
			return new HLPlaceTreeEditPart(obj);
		} else if (obj instanceof HLTransition) {
			return new HLTransitionTreeEditPart(obj);			
		} else if (obj instanceof ObjectNet) {
			return new ObjectNetTreeEditPart(obj);
		} else if (obj instanceof Rule) {
			return new RuleTreeEditPart(obj);
		}

		// Fehler melden
		Assert.isTrue(false, "TreeEditPartsFactory could not create an EditPart for the model element of type " + obj.getClass());
		return null;
	}
}
