package roneditor.gef.editpolicies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;

import roneditor.gef.commands.ron.DeleteHLNodeCommand;
import ronmodel.HLNode;

/**
 * An EditPolicy for (Tree)EditParts of HLNodes to handle deletion requests.
 * 
 * @author Tony Modica
 */
public class HLNodeComponentEditPolicy extends ComponentEditPolicy {

	/**
	 * @return A DeleteHLNodeCommand with the model of the host EditPart set.
	 * 
	 * @see org.eclipse.gef.editpolicies.ComponentEditPolicy#getDeleteCommand(org.eclipse.gef.requests.GroupRequest)
	 */
	@Override
	protected Command getDeleteCommand(@SuppressWarnings("unused")
	final GroupRequest request) {
		final DeleteHLNodeCommand command = new DeleteHLNodeCommand((HLNode) getHost().getModel());
		return command;
	}
}
