/**
 * 
 */
package roneditor.gef.editpolicies.objectnet;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.DirectEditPolicy;
import org.eclipse.gef.requests.DirectEditRequest;

import roneditor.gef.commands.objectnet.SetArcWeightCommand;
import roneditor.gef.editparts.objectnet.ONArcEditPart;
import ronmodel.ONArc;
import ronmodel.ONNode;

/**
 * The direct edit policy for an {@link ONNode}. Creates the appropriate {@link Command} and
 * updates the figure while typing.
 */
public class ONArcDirectEditPolicy extends DirectEditPolicy {

	/**
	 * @see DirectEditPolicy#getDirectEditCommand(DirectEditRequest)
	 */
	protected Command getDirectEditCommand(DirectEditRequest edit) {
		String labelText = (String) edit.getCellEditor().getValue();
		ONArcEditPart label = (ONArcEditPart) getHost();
		try {
			int value = Integer.parseInt(labelText);
			if (value < 0) {
				return null;
			}
			SetArcWeightCommand command = new SetArcWeightCommand((ONArc) label.getModel(), Integer.parseInt(labelText));
			return command;
		} catch (final Exception e) {
			return null;
		}
	}

	/**
	 * @see DirectEditPolicy#showCurrentEditValue(DirectEditRequest)
	 */
	protected void showCurrentEditValue(DirectEditRequest request) {
	}

}
