package roneditor.gef.editpolicies.objectnet;

import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ConnectionEditPolicy;
import org.eclipse.gef.requests.GroupRequest;

import roneditor.gef.commands.objectnet.DeleteArcCommand;
import ronmodel.ONArc;

/**
 * {@link EditPolicy} for an {@link ONArc}.
 */
public class ONArcEditPolicy extends ConnectionEditPolicy {

	public ONArcEditPolicy() {
		super();
	}

	/**
	 * Create the appropriate DeleteArcCommand.
	 * 
	 * @see org.eclipse.gef.editpolicies.ConnectionEditPolicy#getDeleteCommand(org.eclipse.gef.requests.GroupRequest)
	 */
	protected Command getDeleteCommand(GroupRequest request) {
		return new DeleteArcCommand((ONArc) getHost().getModel());
	}

}
