package roneditor.gef.editpolicies.objectnet;

import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;

import roneditor.gef.commands.objectnet.DeleteNodeCommand;
import roneditor.gef.editparts.objectnet.ONNodeEditPart;
import roneditor.gef.figures.objectnet.NodeFigure;
import ronmodel.ONNode;

/**
 * {@link ComponentEditPolicy} for an {@link ONNodeEditPart}.
 */
public class ONNodeComponentEditPolicy extends ComponentEditPolicy {

	public ONNodeComponentEditPolicy() {
		super();
	}

	protected Command createDeleteCommand(GroupRequest deleteRequest) {
		return new DeleteNodeCommand((ONNode) getHost().getModel());
	}


	/**
	 * Provide visual feedback on mouse over
	 */
	@Override
	public void showTargetFeedback(Request request) {
		getHostFigure().setHighlight(true);
	}
	
	/**
	 * Remove visual feedback on mouse out
	 */
	@Override
	public void eraseTargetFeedback(Request request) {
		getHostFigure().setHighlight(false);
	}
	
	public NodeFigure getHostFigure() {
		return (NodeFigure) ((ONNodeEditPart)getHost()).getFigure();		
	}

}
