package roneditor.gef.editpolicies.objectnet;

import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.AbstractEditPolicy;

import roneditor.gef.commands.objectnet.ObjectNetEditPartGraphLayoutCommand;
import roneditor.gef.editparts.objectnet.ObjectNetEditPart;
import ronmodel.ObjectNet;

/**
 * The {@link ObjectNetEditPartGraphLayoutEditPolicy} handles the
 * {@link Request} for the Graph Layout of the {@link ObjectNet}. It returns
 * the {@link ObjectNetEditPartGraphLayoutCommand}.
 */
public class ObjectNetEditPartGraphLayoutEditPolicy extends AbstractEditPolicy {

	public static final String ID = "ObjectNetGraphLayoutEditPolicy";

	public static final String REQUEST = "ObjectNetGraphLayoutEditPolicyRequest";

	private ObjectNetEditPart editPart;

	public ObjectNetEditPartGraphLayoutEditPolicy(ObjectNetEditPart editPart) {
		this.editPart = editPart;
	}

	/**
	 * Get the Command for the Graph Layout. Currently only
	 * <code>ObjectNetEditPartGraphLayoutEditPolicy.REQUEST</code> is handled.
	 */
	public Command getCommand(Request request) {
		if (request.getType() == ObjectNetEditPartGraphLayoutEditPolicy.REQUEST) {
			return new ObjectNetEditPartGraphLayoutCommand(editPart);
		}
		return null;
	}

}
