package roneditor.gef.editpolicies.ron;

import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ConnectionEditPolicy;
import org.eclipse.gef.requests.GroupRequest;

import roneditor.gef.commands.objectnet.DeleteArcCommand;
import roneditor.gef.commands.ron.DeleteHLArcCommand;
import ronmodel.HLArc;
import ronmodel.ONArc;

/**
 * {@link EditPolicy} for an {@link HLArc}.
 */
public class HLArcEditPolicy extends ConnectionEditPolicy {

	public HLArcEditPolicy() {
		super();
	}

	/**
	 * Create the appropriate DeleteHLArcCommand.
	 * 
	 * @see org.eclipse.gef.editpolicies.ConnectionEditPolicy#getDeleteCommand(org.eclipse.gef.requests.GroupRequest)
	 */
	protected Command getDeleteCommand(GroupRequest request) {
		return new DeleteHLArcCommand((HLArc) getHost().getModel());
	}

}
