package roneditor.gef.editpolicies.ron;

import org.eclipse.draw2d.PolygonDecoration;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.editpolicies.ConnectionEndpointEditPolicy;

import roneditor.gef.editparts.objectnet.ONArcEditPart;

/**
 * {@link EditPolicy} for the end-points (e.g. arrow) of an {@link ONArcEditPart}.
 */
public class HLArcEndpointEditPolicy extends ConnectionEndpointEditPolicy {

	public HLArcEndpointEditPolicy() {
		super();
	}

	protected void addSelectionHandles() {
		super.addSelectionHandles();
		getConnectionFigure().setLineWidth(2);
	}

	/**
	 * Returns the {@link PolylineConnection} figure with a line end arrow.
	 */
	protected PolylineConnection getConnectionFigure() {
		PolylineConnection con = (PolylineConnection) ((GraphicalEditPart) getHost()).getFigure();
		// source decoration -->
		// arrow at the end of the line
		PolygonDecoration decoration = new PolygonDecoration();
		con.setSourceDecoration(decoration);

		return con;
	}

	protected void removeSelectionHandles() {
		super.removeSelectionHandles();
		getConnectionFigure().setLineWidth(1);
	}
}
