package roneditor.gef.editpolicies.ron;

import org.eclipse.gef.NodeEditPart;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.DirectEditPolicy;
import org.eclipse.gef.requests.DirectEditRequest;

import roneditor.gef.commands.objectnet.RenameNamedElementCommand;
import roneditor.gef.figures.objectnet.NodeFigure;
import ronmodel.NamedElement;
import ronmodel.ONNode;

/**
 * The direct edit policy for an {@link ONNode}. Creates the appropiate {@link Command} and
 * updates the figure while typing.
 */
public class HLNodeDirectEditPolicy extends DirectEditPolicy {

	/**
	 * @see DirectEditPolicy#getDirectEditCommand(DirectEditRequest)
	 */
	protected Command getDirectEditCommand(DirectEditRequest edit) {
		String labelText = (String) edit.getCellEditor().getValue();
		NodeEditPart label = (NodeEditPart) getHost();
		RenameNamedElementCommand command = new RenameNamedElementCommand();
		command.setNewName(labelText);
		command.setNamedElement((NamedElement) label.getModel());
		return command;
	}

	/**
	 * @see DirectEditPolicy#showCurrentEditValue(DirectEditRequest)
	 */
	protected void showCurrentEditValue(DirectEditRequest request) {
		String value = (String) request.getCellEditor().getValue();
		((NodeFigure) getHostFigure()).setName(value);
		// hack to prevent async layout from placing the cell editor twice.
		getHostFigure().getUpdateManager().performUpdate();
	}

}
