package roneditor.gef.figures.objectnet;

import org.eclipse.draw2d.ConnectionEndpointLocator;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.MidpointLocator;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;

public class ArcFigure extends PolylineConnection {
	protected Label relationshipLabel;

	protected Label weightLabel;

	protected int weight;

	public ArcFigure(String name, int weight) {
		super();
		setForegroundColor(new Color(null, 128, 128, 128));
		ConnectionEndpointLocator relationshipLocator = new ConnectionEndpointLocator(this, false);
		MidpointLocator foo = new MidpointLocator(this, 0);
		relationshipLocator.setUDistance(5);
		relationshipLocator.setVDistance(10);
		relationshipLabel = new Label(name);
		weightLabel = new Label(String.valueOf(weight));
		weightLabel.setBackgroundColor(new Color(null, 255, 255, 255));
		weightLabel.setForegroundColor(new Color(null, 0, 0, 0));
		weightLabel.setOpaque(true);
		add(weightLabel, foo);
	}

	public void paint(Graphics graphics) {
		graphics.setAntialias(SWT.ON);
		super.paint(graphics);
	}

	public Rectangle getLabelArea() {
		Rectangle rect = weightLabel.getClientArea();
		translateToAbsolute(rect);
		return rect;
	}

	public void setWeight(int weight) {
		this.weight = weight;
		weightLabel.setText(String.valueOf(weight));
	}

	public int getWeight() {
		return weight;
	}

	public void setName(String name) {
		relationshipLabel.setText(name);
	}

	public String getName() {
		return relationshipLabel.getText();
	}

}
