package roneditor.gef.figures.objectnet;

import org.eclipse.draw2d.ChopboxAnchor;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.XYLayout;
import org.eclipse.swt.graphics.Color;

abstract public class NodeFigure extends RectangleFigure {
	protected Label nameLabel;

	protected XYLayout layout;

	protected ChopboxAnchor incomingConnectionAnchor;

	protected ChopboxAnchor outgoingConnectionAnchor;

	protected int width = 10, height = 10;

	protected boolean ruleMode;

	protected boolean glow;
	
	protected boolean highlight; 


	public NodeFigure() {
		layout = new XYLayout();
		setLayoutManager(layout);
		nameLabel = new Label(" ");
		add(nameLabel);
		setBackgroundColor(ColorConstants.white);
		setForegroundColor(ColorConstants.black);
		setOpaque(false);
	}

	public void setGlow(boolean glow) {
		this.glow = glow;
		repaint();
	}

	public void setHighlight(boolean highlight) {
		this.highlight = highlight;
		// Update Color
		setColor(getColor());
		repaint();
	}
	
	public void setName(String name) {
		nameLabel.setText(name);
	}

	public String getName() {
		return nameLabel.getText();
	}

	public ChopboxAnchor getSourceConnectionAnchor() {
		return outgoingConnectionAnchor;
	}

	public ChopboxAnchor getTargetConnectionAnchor() {
		return incomingConnectionAnchor;
	}

	/**
	 * @return the width
	 */
	public int getWidth() {
		return width;
	}

	/**
	 * @param width
	 *            the width to set
	 */
	public void setWidth(int width) {
		this.width = width;
	}

	/**
	 * @return the height
	 */
	public int getHeight() {
		return height;
	}

	/**
	 * @param height
	 *            the height to set
	 */
	public void setHeight(int height) {
		this.height = height;
	}

	public boolean isRuleMode() {
		return ruleMode;
	}

	public void setColor(Color c) {
		setBackgroundColor(c);
	}

	public Color getColor() {
		return getBackgroundColor();
	}
	
	public void setRuleMode(boolean ruleMode) {
		this.ruleMode = ruleMode;
	}

	/*
	 * protected boolean useLocalCoordinates() { return false; }
	 */

}
