package roneditor.gef.figures.objectnet;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Ellipse;
import org.eclipse.draw2d.FigureUtilities;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.XYLayout;

/**
 * The {@link PlaceGhostFigure} is used when dragging the PlaceFigure. 
 */
public class PlaceGhostFigure extends PlaceFigure {

	public PlaceGhostFigure(PlaceFigure placeFigure) {
		layout = new XYLayout();
		setLayoutManager(layout);

		nameLabel = new Label(placeFigure.getName());
		nameLabel.setFont(placeFigure.nameLabel.getFont());
		nameLabel.setForegroundColor(ColorConstants.gray);
		add(nameLabel);

		setBackgroundColor(ColorConstants.white);

		setOpaque(false);
		setOutline(false);
		setFill(false);

		placeEllipse = new Ellipse();
		placeEllipse.setLineStyle(Graphics.LINE_SOLID);
		placeEllipse.setForegroundColor(ColorConstants.gray);
		FigureUtilities.makeGhostShape(placeEllipse);
		add(placeEllipse);

		tokenLabel = new Label("");
		tokenLabel.setFont(placeFigure.tokenLabel.getFont());
		tokenLabel.setForegroundColor(ColorConstants.gray);
		setTokens(placeFigure.getTokens());
		add(tokenLabel);

	}
}
