package roneditor.gef.figures.objectnet;

import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.swt.graphics.Color;

public class ShadedRectangleFigure extends RectangleFigure {
	
	protected Color gradientColorStart;
	protected Color gradientColorEnd;
	
	
	public void setGradientColor(Color gradientColorStart, Color gradientColorEnd) {
		this.gradientColorStart = gradientColorStart;
		this.gradientColorEnd = gradientColorEnd;
	}
	
	/**
	 * Fill the shape with a fancy gradient.
	 */
	@Override
	protected void fillShape(Graphics graphics) {
		Color oldForegroundColor = getForegroundColor();
		Color oldBackgroundColor = getForegroundColor();
		if ( gradientColorStart != null )
			graphics.setForegroundColor(gradientColorStart);
		if ( gradientColorEnd != null )
			graphics.setBackgroundColor(gradientColorEnd);
		if ( graphics.getXORMode() )
			graphics.fillRectangle(getBounds());
		else
			graphics.fillGradient(getBounds(),true);
		graphics.setForegroundColor(oldForegroundColor);
		graphics.setBackgroundColor(oldBackgroundColor);
	}
	
	@Override
	protected void outlineShape(Graphics graphics) {
		super.outlineShape(graphics);
	}
	
}
