package roneditor.gef.palette.ron;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.CreationToolEntry;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.gef.tools.CreationTool;
import org.eclipse.jface.resource.ImageDescriptor;

import roneditor.gef.tools.ron.HLTransitionCreationTool;
import ronmodel.HLPlaceType;
import ronmodel.HLTransitionKind;

public class HLTransitionCreationToolEntry extends CreationToolEntry {

	
	HLTransitionKind kind;
	
	public HLTransitionCreationToolEntry(String label, String shortDesc, CreationFactory factory, ImageDescriptor iconSmall,
			ImageDescriptor iconLarge) {
		super(label, shortDesc, factory, iconSmall, iconLarge);
	}

	public HLTransitionCreationToolEntry(String label, String shortDesc, CreationFactory factory, HLTransitionKind k, ImageDescriptor iconSmall,
			ImageDescriptor iconLarge) {
		super(label, shortDesc, factory, iconSmall, iconLarge);
		this.kind = k;
	}
	
	/**
	 * Returns a new CreationTool for this entry.
	 */
	public Tool createTool() {
		return new HLTransitionCreationTool(factory,kind);
	}
}
