package roneditor.gef.tools.objectnet;

import javax.swing.CellEditor;

import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.tools.CellEditorLocator;

import roneditor.gef.tools.NamedElementEditManager;
import ronmodel.ONArc;

/**
 * The <code>ONArcEditManager</code> is used by a DirectEdit to feed the
 * inital weight value from the {@link ONArc} to the {@link CellEditor}.
 */
public class ONArcEditManager extends NamedElementEditManager {

	/**
	 * @param source
	 * @param locator
	 */
	public ONArcEditManager(GraphicalEditPart source, CellEditorLocator locator) {
		super(source, locator);
	}

	/**
	 * Initalize the current CellEditor with the weight value from the ONArc
	 * figure.
	 */
	protected void initCellEditor() {
		ONArc onArc = (ONArc) getEditPart().getModel();
		getCellEditor().setValue(String.valueOf(onArc.getWeight()));
		updateActionBars();
	}

}
