package roneditor.gef.tools.objectnet;

import java.util.Map;

import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.gef.requests.DirectEditRequest;
import org.eclipse.gef.tools.ConnectionCreationTool;
import org.eclipse.jface.viewers.CellEditor;

import roneditor.gef.commands.objectnet.ConnectPlaceTransitionCommand;
import roneditor.gef.commands.objectnet.ConnectTransitionPlaceCommand;
import roneditor.gef.editparts.objectnet.ONArcEditPart;
import ronmodel.NamedElement;
import ronmodel.ONArc;


public class ObjectNetConnectionCreationTool extends ConnectionCreationTool {

	public ObjectNetConnectionCreationTool() {
		super();
	}

	public ObjectNetConnectionCreationTool(CreationFactory factory) {
		super(factory);
	}

	/**
	 * Execute either {@link ConnectPlaceTransitionCommand} or {@link ConnectTransitionPlaceCommand} and
	 * finally perform an {@link DirectEditRequest}. This will then show the {@link CellEditor} for editing
	 * the {@link ONArc} weight after creation.
	 */
	protected void executeCurrentCommand() {
		Command command = getCurrentCommand();
		super.executeCurrentCommand();
		if (command instanceof ConnectPlaceTransitionCommand || command instanceof ConnectTransitionPlaceCommand) {
			NamedElement namedElement;
			if (command instanceof ConnectPlaceTransitionCommand) {
				namedElement = ((ConnectPlaceTransitionCommand) command).getArc();
			} else {
				namedElement = ((ConnectTransitionPlaceCommand) command).getArc();
			}
			Map reg = getCurrentViewer().getEditPartRegistry();
			ONArcEditPart editPart = (ONArcEditPart) reg.get(namedElement);
			Request request = new Request(RequestConstants.REQ_DIRECT_EDIT);
			editPart.performRequest(request);
		}
	}

}