package roneditor.gef.tools.objectnet;

import java.util.Map;

import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.gef.tools.CreationTool;

import roneditor.gef.commands.objectnet.CreateNodeCommand;
import roneditor.gef.editparts.objectnet.ONNodeEditPart;
import ronmodel.ONNode;

public class ObjectNetCreationTool extends CreationTool {

	public ObjectNetCreationTool() {
		super();
	}

	public ObjectNetCreationTool(CreationFactory factory) {
		super(factory);
	}

	protected void executeCurrentCommand() {
		// Store current command
		Command command = getCurrentCommand();

		super.executeCurrentCommand();

		if (command instanceof CreateNodeCommand) {
			ONNode node = ((CreateNodeCommand) command).getONNode();
			Map reg = getCurrentViewer().getEditPartRegistry();
			ONNodeEditPart editPart = (ONNodeEditPart) reg.get(node);
			Request request = new Request(RequestConstants.REQ_DIRECT_EDIT);
			editPart.performRequest(request);
		}
	}
}