package roneditor.gef.tools.objectnet;

/**
 * @author seb
 */

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreateConnectionRequest;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.gef.tools.ConnectionCreationTool;

import roneditor.gef.commands.objectnet.ConnectPlaceTransitionCommand;
import roneditor.gef.commands.objectnet.ConnectTransitionPlaceCommand;
import roneditor.gef.commands.objectnet.CreateNodeCommand;
import roneditor.model.ModelCreationFactory;
import ronmodel.ONArc;
import ronmodel.ONPlace;
import ronmodel.ONTransition;

public class ObjectNetMagicConnectionCreationTool extends
		ConnectionCreationTool {
	
	static int placeno = 0;
	static int transno = 0;
	
	public ObjectNetMagicConnectionCreationTool() {
		super();
	}

	public ObjectNetMagicConnectionCreationTool(CreationFactory factory) {
		super(factory);
	}
	
	protected  boolean	handleCreateConnection()
	{
		
		
		//seb: creation request abgreifen und command auslesen
		CreateConnectionRequest r = (CreateConnectionRequest)this.getSourceRequest();
		//seb: gewicht default auf 1 setzen
		ONArc a = (ONArc)r.getNewObject();
		a.setWeight(1);
		if (r.getTargetEditPart() != null ) return super.handleCreateConnection();
		Command startcommand = r.getStartCommand();

		//seb: neuen EditPart erstellen
		CreateRequest createrequest = new CreateRequest();
		
		createrequest.setLocation(getLocation());
	
		String name = "Node";
		if (startcommand instanceof ConnectPlaceTransitionCommand) {
			System.out.print("creating Trans.\n");
			createrequest.setFactory(new ModelCreationFactory(ONTransition.class));
			ONTransition o = (ONTransition)createrequest.getNewObject(); 
			ConnectPlaceTransitionCommand commandSC = (ConnectPlaceTransitionCommand) startcommand;
			commandSC.setTarget(o);	
			name = "Transition" + transno++;
		}
		else if (startcommand instanceof ConnectTransitionPlaceCommand){
			System.out.print("creating Place\n");
			createrequest.setFactory(new ModelCreationFactory(ONPlace.class));
			ONPlace o = (ONPlace)createrequest.getNewObject();
			ConnectTransitionPlaceCommand commandSC = (ConnectTransitionPlaceCommand) startcommand;
			commandSC.setTarget(o);
			name = "Place" + placeno++;
		}
		//seb: Node erstellen
		CreateNodeCommand c = (CreateNodeCommand)getCurrentViewer().getRootEditPart().getContents().getCommand(createrequest);
		c.setName(name);
		getDomain().getCommandStack().execute(c);
		//seb: command ausf�hren
		setCurrentCommand(startcommand);	
		this.executeCurrentCommand();
		
		return super.handleCreateConnection();
	}
	
/*	protected void executeCurrentCommand() {
		Command command = getCurrentCommand();
		super.executeCurrentCommand();
		
//seb: zum schnelleren testen deaktiviert
		if (command instanceof ConnectPlaceTransitionCommand || command instanceof ConnectTransitionPlaceCommand ) {
			NamedElement namedElement;
			if (command instanceof ConnectPlaceTransitionCommand) {
				namedElement = ((ConnectPlaceTransitionCommand)command).getArc();
			}
			else {
				namedElement = ((ConnectTransitionPlaceCommand)command).getArc();
			}
			Map reg = getCurrentViewer().getEditPartRegistry();
			ONArcEditPart editPart = (ONArcEditPart) reg.get(namedElement);
			Request request = new Request(RequestConstants.REQ_DIRECT_EDIT);
			editPart.performRequest(request);
		}

	}
*/
}
