package roneditor.gef.tools.objectnet;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.EditPartViewer.Conditional;
import org.eclipse.gef.tools.AbstractTool;
import org.eclipse.gef.tools.SelectionTool;
import org.eclipse.swt.events.MouseEvent;

import roneditor.gef.editparts.objectnet.ONTransitionEditPart;
import roneditor.gef.figures.objectnet.NodeFigure;
import roneditor.ui.dialog.FireDialog;

public class TransitionSelectionTool extends SelectionTool {

	FireDialog fireDialog;
	
	public TransitionSelectionTool(FireDialog fireDialog) {
		this.fireDialog = fireDialog;
	}

	private static final int FLAG_TARGET_FEEDBACK = AbstractTool.MAX_FLAG << 2;
	
	@Override
	protected void showHoverFeedback() {
		if (getTargetEditPart() == null)
			return;
		if (getTargetHoverRequest() == null)
			return;

		
		System.out.println("TransitionSelectionTool.showHoverFeedback()");
//		NodeFigure nf = (NodeFigure) ((ONTransitionEditPart)getTargetEditPart()).getFigure();
//		nf.setGlow(true);
		//((NodeFigure) getHostFigure()).setGlow(false);
		// TODO Auto-generated method stub
		super.showHoverFeedback();
	}
	
	
	@Override
	protected void showTargetFeedback() {
		super.showTargetFeedback();

		if (getTargetEditPart() == null) return;
		if ( getTargetEditPart() instanceof ONTransitionEditPart ) {
			NodeFigure nf = (NodeFigure) ((ONTransitionEditPart)getTargetEditPart()).getFigure();
			nf.setGlow(true);
		}

		
	}
	
	@Override
	protected void eraseHoverFeedback() {
		// TODO Auto-generated method stub
		super.eraseHoverFeedback();
	}
	
	@Override
	protected void eraseTargetFeedback() {
		super.eraseTargetFeedback();

		
		if (getTargetEditPart() == null) return;
		if ( getTargetEditPart() instanceof ONTransitionEditPart ) {
			NodeFigure nf = (NodeFigure) ((ONTransitionEditPart)getTargetEditPart()).getFigure();
			nf.setGlow(false);
		}
	}
	
	
	
	@Override
	public void mouseDrag(final MouseEvent e, final EditPartViewer viewer) {
	}

	@Override
	public void mouseDoubleClick(MouseEvent e, EditPartViewer viewer) {
	}

	@Override
	public void mouseHover(MouseEvent me, EditPartViewer viewer) {
	}

	@Override
	public void mouseUp(MouseEvent me, EditPartViewer viewer) {
		if (!isViewerImportant(viewer))
			return;
		setViewer(viewer);
		getCurrentInput().setInput(me);
		getCurrentInput().setMouseButton(me.button, false);
		handleButtonUp(me.button);
	}

	@Override
	protected Conditional getTargetingConditional() {
		return new Conditional() {
			public boolean evaluate(EditPart editpart) {
				return (editpart instanceof ONTransitionEditPart) && ((ONTransitionEditPart) editpart).canFire();
			}
		};
	}

}
