package roneditor.gef.tools.ron;

import java.util.Map;

import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.gef.tools.CreationTool;

import roneditor.gef.commands.objectnet.CreateNodeCommand;
import roneditor.gef.commands.ron.CreateHLNodeCommand;
import roneditor.gef.commands.ron.CreateHLPlaceCommand;
import roneditor.gef.editparts.objectnet.ONNodeEditPart;
import roneditor.gef.editparts.ron.HLNodeEditPart;
import ronmodel.HLNode;
import ronmodel.HLPlaceType;
import ronmodel.ONNode;

public class HLPlaceCreationTool extends CreationTool {

	HLPlaceType type;
	
	public HLPlaceCreationTool() {
		super();
	}

	public HLPlaceCreationTool(CreationFactory factory) {
		super(factory);
	}

	
	public HLPlaceCreationTool(CreationFactory factory, HLPlaceType t) {
		super(factory);
		type = t;
	}
	protected void executeCurrentCommand() {
		// Store current command
		CreateHLPlaceCommand command = (CreateHLPlaceCommand )getCurrentCommand();
		if (type != null && command != null) command.setType(type);
		super.executeCurrentCommand();
		
		// directEdit
		if (command instanceof CreateHLNodeCommand) {
			HLNode node = ((CreateHLNodeCommand) command).getHLNode();
			Map reg = getCurrentViewer().getEditPartRegistry();
			HLNodeEditPart editPart = (HLNodeEditPart) reg.get(node);
			Request request = new Request(RequestConstants.REQ_DIRECT_EDIT);
			editPart.performRequest(request);
		}
	}
}