package roneditor.gef.tools.ron;

import java.util.Map;

import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.gef.tools.CreationTool;

import roneditor.gef.commands.objectnet.CreateNodeCommand;
import roneditor.gef.commands.ron.CreateHLNodeCommand;
import roneditor.gef.commands.ron.CreateHLPlaceCommand;
import roneditor.gef.commands.ron.CreateHLTransitionCommand;
import roneditor.gef.editparts.objectnet.ONNodeEditPart;
import roneditor.gef.editparts.ron.HLNodeEditPart;
import ronmodel.HLNode;
import ronmodel.HLPlaceType;
import ronmodel.HLTransitionKind;
import ronmodel.ONNode;


public class HLTransitionCreationTool extends CreationTool {

	HLTransitionKind kind;
	
	public HLTransitionCreationTool() {
		super();
	}

	public HLTransitionCreationTool(CreationFactory factory) {
		super(factory);
	}

	
	public HLTransitionCreationTool(CreationFactory factory, HLTransitionKind k) {
		super(factory);
		kind = k;
	}
	protected void executeCurrentCommand() {
		// Store current command
		CreateHLTransitionCommand command = (CreateHLTransitionCommand )getCurrentCommand();
		if (kind != null && command != null) command.setKind(kind);
		super.executeCurrentCommand();

		// directEdit
		if (command instanceof CreateHLNodeCommand) {
			HLNode node = ((CreateHLNodeCommand) command).getHLNode();
			Map reg = getCurrentViewer().getEditPartRegistry();
			HLNodeEditPart editPart = (HLNodeEditPart) reg.get(node);
			Request request = new Request(RequestConstants.REQ_DIRECT_EDIT);
			editPart.performRequest(request);
		}
	}
}