package roneditor.gef.tools.ron;

import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.tools.CellEditorLocator;

import roneditor.gef.figures.objectnet.NodeFigure;
import roneditor.gef.tools.NamedElementEditManager;

/**
 * The <code>NodeEditManager</code> is an {@link NamedElementEditManager}, that
 * will update the {@link NodeFigure} when changes while the DirectEdit occur.
 */
public class NodeEditManager extends NamedElementEditManager {

	/**
	 * @param source
	 * @param locator
	 */
	public NodeEditManager(GraphicalEditPart source, CellEditorLocator locator) {
		super(source, locator);
	}

	protected void initCellEditor() {
		NodeFigure nodeFigure = (NodeFigure) getEditPart().getFigure();
		getCellEditor().setValue(nodeFigure.getName());
		updateActionBars();
	}

}
