package roneditor.gef.tools.rule;

import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.Tool;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.gef.tools.ConnectionCreationTool;

import ronmodel.ONNode;

/**
 * This {@link Tool} is used for creating a mapping between two {@link ONNode}
 * of two distinct {@link EditPartViewer}. In particular the mapping have to
 * follow the given constraints....
 * 
 * 
 */
public class RuleMappingCreationTool extends ConnectionCreationTool {

	public RuleMappingCreationTool() {
		super();
	}

	public RuleMappingCreationTool(CreationFactory factory) {
		super(factory);
	}

	protected boolean handleFocusLost() {
		return false;
	}

	protected boolean handleMove() {
		if (isInState(STATE_CONNECTION_STARTED | STATE_INITIAL | STATE_ACCESSIBLE_DRAG_IN_PROGRESS)) {
			updateTargetRequest();
			updateTargetUnderMouse();
			showSourceFeedback();
			showTargetFeedback();
			setCurrentCommand(getCommand());
		}
		return true;
	}
}
