package roneditor.ui.contextmenu;

import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.ui.actions.ActionRegistry;
import org.eclipse.gef.ui.actions.GEFActionConstants;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.ui.actions.ActionFactory;

import roneditor.gef.actions.objectnet.FireTransitionAction;
import roneditor.ui.part.ObjectNetPage;

/**
 * This is used to populate the context menu for the Viewer in the
 * {@link ObjectNetPage}.
 * 
 * @author Tony Modica
 */
public class ObjectNetPageContextMenuProvider extends ContextMenuProviderWithActionRegistry {

	public ObjectNetPageContextMenuProvider(final EditPartViewer viewer, final ActionRegistry actionRegistry) {
		super(viewer, actionRegistry);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.ContextMenuProvider#buildContextMenu(org.eclipse.jface.action.IMenuManager)
	 */
	@Override
	public void buildContextMenu(final IMenuManager menuManager) {
		// HINT Hier wird das Kontextmen� �ber den im Editor registrierten
		// Actions aufgebaut
		GEFActionConstants.addStandardActionGroups(menuManager);

		// Actions in UNDO group
		String group = GEFActionConstants.GROUP_UNDO;
		appendActionToGroup(menuManager, ActionFactory.UNDO.getId(), group);
		appendActionToGroup(menuManager, ActionFactory.REDO.getId(), group);

		// Actions in EDIT group
		group = GEFActionConstants.GROUP_EDIT;
		dynamicAppendActionToGroup(menuManager, GEFActionConstants.DIRECT_EDIT, group);
		appendActionToGroup(menuManager, ActionFactory.DELETE.getId(), group);
		appendActionToGroup(menuManager, ActionFactory.COPY.getId(), group);
		appendActionToGroup(menuManager, ActionFactory.CUT.getId(), group);
		appendActionToGroup(menuManager, ActionFactory.PASTE.getId(), group);
		appendActionToGroup(menuManager, FireTransitionAction.ID, group);

	}
}
