package roneditor.ui.dialog;

import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.Tool;

import roneditor.gef.editparts.objectnet.ObjectNetEditPartFactory;
import roneditor.gef.tools.objectnet.TransitionSelectionTool;
import ronmodel.ONArc;
import ronmodel.ONPlace;
import ronmodel.ONTransition;
import ronmodel.ObjectNet;

public class FireDialog extends AbstractFireDialog {

	public FireDialog(final ObjectNet objectNet) {
		super(objectNet);
	}

	@Override
	protected EditPartFactory getEditPartFactory() {
		return new ObjectNetEditPartFactory();
	}

	@Override
	protected boolean isActivated(final ONTransition transition) {
		for (final Object elem : transition.getIncoming()) {
			final ONArc arc = (ONArc) elem;
			final ONPlace prePlace = (ONPlace) arc.getSource();
			if (prePlace.getTokens() < arc.getWeight()) {
				return false;
			}
		}
		return true;
	}

	@Override
	protected Tool createMappingTool() {
		return new TransitionSelectionTool(this);
	}

}
