package roneditor.ui.navigator;


import org.eclipse.core.resources.IFile;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;

import ronmodel.HLPlace;

public class RONAdapterFactoryLabelProvider extends AdapterFactoryLabelProvider
{

	public RONAdapterFactoryLabelProvider(){
		super(RONAdapterFactoryProvider.getAdapterFactory());
	}

	/**
	 * Returns the platform icon for a file. You can replace with your own icon
	 * If not a IFile, then passes to the regular EMF.Edit providers 
	 */
	public Image getImage(Object object) {
		if (object instanceof IFile)
			return PlatformUI.getWorkbench().getSharedImages().getImage(ISharedImages.IMG_OBJ_FILE);
		return super.getImage(object);
	}

	public String getText(Object object) {
		if (object instanceof IFile)
			return ((IFile)object).getName();
		if (object instanceof HLPlace)
		{
			return ((HLPlace)object).getName();
		}
		else
		return super.getText(object);
	}
}

