package roneditor.ui.navigator;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.ReflectiveItemProviderAdapterFactory;
import org.eclipse.emf.edit.provider.resource.ResourceItemProviderAdapterFactory;

import roneditor.model.provider.RonmodelItemProviderAdapterFactory;

/**
 * 
 * @author choeger
 *
 */
public class RONAdapterFactoryProvider {

	private static ComposedAdapterFactory adapterFactory;

	public final static List<AdapterFactory> createFactoryList(){
		System.err.println("RONAdapterFactoryProvider.createFactoryList()");
		List<AdapterFactory> factories = new ArrayList<AdapterFactory>();

		factories.add(new RonmodelItemProviderAdapterFactory());
		// these are EMF generic providers
		factories.add(new ResourceItemProviderAdapterFactory());
		factories.add(new ReflectiveItemProviderAdapterFactory());
		// ... add other provider adapter factories for your model as needed
		// if you don't know what to add, look at the creation of the adapter factory
		// in your generated editor
		return factories;
	}

	public final static ComposedAdapterFactory getAdapterFactory(){
		System.err.println("RONAdapterFactoryProvider.getAdapterFactory()");
		if (adapterFactory == null) 
			adapterFactory = new ComposedAdapterFactory(createFactoryList());
		return adapterFactory;
	}
}
