package roneditor.ui.part;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.commands.CommandStack;
import org.eclipse.gef.ui.properties.UndoablePropertySheetEntry;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.views.properties.IPropertySheetEntry;
import org.eclipse.ui.views.properties.PropertySheetPage;
import org.eclipse.ui.views.properties.PropertySheetSorter;


public abstract class OwnAbstractMultiViewerPage extends AbstractMultiViewerPage {

	
	
	protected OwnAbstractMultiViewerPage(final EObject model, final IEditorPart editor) {
		super(model,editor);
	}

	
	public Object getAdapter(final Class type) {
		if (type == org.eclipse.ui.views.properties.IPropertySheetPage.class) {
			/*
			 * The PropertySheetPage is extended so that a PropertySheetSorter
			 * taht does nothing (comapares everything as equal)is being set.
			 * This way the properties will be displayed in the order they are
			 * returned by the property sources instead of sorted
			 * alphabetically.
			 */
			final PropertySheetPage page = new PropertySheetPage() {
				/*
				 * (non-Javadoc)
				 * 
				 * @see org.eclipse.ui.views.properties.PropertySheetPage#createControl(org.eclipse.swt.widgets.Composite)
				 */
				@Override
				public void createControl(Composite parent) {
					setSorter(new PropertySheetSorter() {
						@Override
						public int compare(IPropertySheetEntry entryA, IPropertySheetEntry entryB) {
							return 0;
						}
					});
					super.createControl(parent);
				}
			};
			// set the PropertySheetPage to use our command stack
			page.setRootEntry(new UndoablePropertySheetEntry( (CommandStack) getEditor().getAdapter(CommandStack.class) ));
			return page;
		}
		return super.getAdapter(type);
	}

}
