package roneditor.ui.wizard;

import java.util.List;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.IWorkbench;

import ronmodel.ONTransition;

public class ChooseONTransitionWizard extends Wizard implements INewWizard  {
	
	private ChooseONTransitionWizardPage page;

	private IStructuredSelection selection;

	private IWorkbench workbench;
	
	private ONTransition activeTransition;
	 
	private List<ONTransition> transitions; 
	
	
	public ChooseONTransitionWizard(List<ONTransition> transitions) {
		setTransitions(transitions);
	}
	
	@Override
	public void addPages() {
		page = new ChooseONTransitionWizardPage(workbench, selection);
		addPage(page);
	}
	
	@Override
	public boolean performFinish() {
		return true;
	}

	public void init(IWorkbench workbench, IStructuredSelection selection) {
		this.workbench = workbench;
		this.selection = selection;
	}


	public ONTransition getSelectedTransition() {
		return activeTransition;
	}
	
	public void setSelectedTransition(ONTransition transition) {
		activeTransition = transition;
	}
	
	public List<ONTransition> getTransitions() {
		return transitions;
	}


	public void setTransitions(List<ONTransition> transitions) {
		this.transitions = transitions;
	}

}
