package roneditor.ui.wizard;

import java.util.List;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbench;

import ronmodel.ONTransition;

public class ChooseONTransitionWizardPage extends WizardPage implements SelectionListener {

	protected Combo combo;

	protected ChooseONTransitionWizardPage(final IWorkbench workbench,
			final IStructuredSelection selection) {
		super("Choose the Transition to fire");
		setTitle("Choose a transition");
		setDescription("Choose the ON Transition that should be fired");
	}

	public void createControl(Composite parent) {
		Composite composite = new Composite(parent, SWT.NULL);

		GridLayout gl = new GridLayout();
		int ncol = 1;
		gl.numColumns = ncol;
		composite.setLayout(gl);

		List<ONTransition> transitions = getCastedWizard().getTransitions();

		new Label(composite, SWT.NONE).setText("Please choose the transition you want to fire:");

		combo = new Combo(composite, SWT.READ_ONLY);
		for (ONTransition transition : transitions) {
			combo.add(transition.getName());
		}
		combo.select(0);
		combo.setFocus();
		combo.addSelectionListener(this);

		setControl(composite);
	}

	public ONTransition getSelectedTransition() {
		List<ONTransition> transitions = getCastedWizard().getTransitions();
		return  transitions.get( combo.getSelectionIndex() );
	}
	
	protected ChooseONTransitionWizard getCastedWizard() {
		return (ChooseONTransitionWizard) getWizard();	
	}
	
	public boolean isPageComplete() {
		getCastedWizard().setSelectedTransition(getSelectedTransition());
		return true;
	}


	public void widgetDefaultSelected(SelectionEvent e) {
	}

	public void widgetSelected(SelectionEvent e) {
		getWizard().getContainer().updateButtons();
	}

}
