package roneditor.ui.wizard;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Spinner;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbench;

public class CreateTokenWizardPage extends WizardPage implements Listener {

	Text tokenName;

	Spinner initalNAC;

	Label nacLabel;

	protected CreateTokenWizardPage(final IWorkbench workbench, final IStructuredSelection selection) {
		super("Create a new Token");
		setTitle("Create a new Token");
		setDescription("Create a new Token on HL-Places");
	}

	public void createControl(Composite parent) {
		GridData gd;
		Composite composite = new Composite(parent, SWT.NULL);

		GridLayout gl = new GridLayout();
		int ncol = 3;
		gl.numColumns = ncol;
		composite.setLayout(gl);

		// Name Text Field
		new Label(composite, SWT.NONE).setText("Name:");
		tokenName = new Text(composite, SWT.BORDER);
		gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.horizontalSpan = ncol - 1;
		tokenName.setLayoutData(gd);
		tokenName.setFocus();

		nacLabel = new Label(composite, SWT.NONE);
		nacLabel.setText("NACs:");
		initalNAC = new Spinner(composite, SWT.BORDER);
		initalNAC.setMinimum(1);
		initalNAC.setMaximum(100);
		initalNAC.setSelection(1);
		initalNAC.setIncrement(1);
		initalNAC.setPageIncrement(10);

		nacLabel.setVisible(false);
		initalNAC.setVisible(false);

		setControl(composite);
		addListeners();
	}

	public boolean isPageComplete() {
		CreateTokenWizard wizard = (CreateTokenWizard) getWizard();
		if (tokenName.getText().length() == 0) {
			return false;
		}
		wizard.setTokenName(tokenName.getText());
		wizard.setInitialNacs(initalNAC.getSelection());
		return true;
	}

	private void addListeners() {
		tokenName.addListener(SWT.KeyUp, this);
		initalNAC.addListener(SWT.Selection, this);
	}

	public void handleEvent(Event event) {
		if (tokenName.getText().length() == 0) {
			setErrorMessage("Name of the Token is empty");
		} else {
			setErrorMessage(null);
		}
		getWizard().getContainer().updateButtons();
	}

}
