/**
 * <copyright>
 * </copyright>
 *
 * $Id: HLNode.java,v 1.2 2007/06/21 18:26:13 talisa Exp $
 */
package ronmodel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>HL Node</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ronmodel.HLNode#getIncoming <em>Incoming</em>}</li>
 *   <li>{@link ronmodel.HLNode#getOutgoing <em>Outgoing</em>}</li>
 *   <li>{@link ronmodel.HLNode#getRon <em>Ron</em>}</li>
 *   <li>{@link ronmodel.HLNode#getX <em>X</em>}</li>
 *   <li>{@link ronmodel.HLNode#getY <em>Y</em>}</li>
 *   <li>{@link ronmodel.HLNode#getWidth <em>Width</em>}</li>
 *   <li>{@link ronmodel.HLNode#getHeight <em>Height</em>}</li>
 * </ul>
 * </p>
 *
 * @see ronmodel.RonmodelPackage#getHLNode()
 * @model abstract="true"
 * @generated
 */
public interface HLNode extends NamedElement {
	/**
	 * Returns the value of the '<em><b>Incoming</b></em>' reference list.
	 * The list contents are of type {@link ronmodel.HLArc}.
	 * It is bidirectional and its opposite is '{@link ronmodel.HLArc#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Incoming</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Incoming</em>' reference list.
	 * @see ronmodel.RonmodelPackage#getHLNode_Incoming()
	 * @see ronmodel.HLArc#getTarget
	 * @model type="ronmodel.HLArc" opposite="target"
	 * @generated
	 */
	EList getIncoming();

	/**
	 * Returns the value of the '<em><b>Outgoing</b></em>' reference list.
	 * The list contents are of type {@link ronmodel.HLArc}.
	 * It is bidirectional and its opposite is '{@link ronmodel.HLArc#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Outgoing</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Outgoing</em>' reference list.
	 * @see ronmodel.RonmodelPackage#getHLNode_Outgoing()
	 * @see ronmodel.HLArc#getSource
	 * @model type="ronmodel.HLArc" opposite="source"
	 * @generated
	 */
	EList getOutgoing();

	/**
	 * Returns the value of the '<em><b>Ron</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link ronmodel.RON#getNodes <em>Nodes</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Ron</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Ron</em>' container reference.
	 * @see #setRon(RON)
	 * @see ronmodel.RonmodelPackage#getHLNode_Ron()
	 * @see ronmodel.RON#getNodes
	 * @model opposite="nodes"
	 * @generated
	 */
	RON getRon();

	/**
	 * Sets the value of the '{@link ronmodel.HLNode#getRon <em>Ron</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ron</em>' container reference.
	 * @see #getRon()
	 * @generated
	 */
	void setRon(RON value);

	/**
	 * Returns the value of the '<em><b>X</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>X</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>X</em>' attribute.
	 * @see #setX(int)
	 * @see ronmodel.RonmodelPackage#getHLNode_X()
	 * @model required="true"
	 * @generated
	 */
	int getX();

	/**
	 * Sets the value of the '{@link ronmodel.HLNode#getX <em>X</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>X</em>' attribute.
	 * @see #getX()
	 * @generated
	 */
	void setX(int value);

	/**
	 * Returns the value of the '<em><b>Y</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Y</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Y</em>' attribute.
	 * @see #setY(int)
	 * @see ronmodel.RonmodelPackage#getHLNode_Y()
	 * @model required="true"
	 * @generated
	 */
	int getY();

	/**
	 * Sets the value of the '{@link ronmodel.HLNode#getY <em>Y</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Y</em>' attribute.
	 * @see #getY()
	 * @generated
	 */
	void setY(int value);

	/**
	 * Returns the value of the '<em><b>Width</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Width</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Width</em>' attribute.
	 * @see #setWidth(int)
	 * @see ronmodel.RonmodelPackage#getHLNode_Width()
	 * @model required="true"
	 * @generated
	 */
	int getWidth();

	/**
	 * Sets the value of the '{@link ronmodel.HLNode#getWidth <em>Width</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Width</em>' attribute.
	 * @see #getWidth()
	 * @generated
	 */
	void setWidth(int value);

	/**
	 * Returns the value of the '<em><b>Height</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Height</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Height</em>' attribute.
	 * @see #setHeight(int)
	 * @see ronmodel.RonmodelPackage#getHLNode_Height()
	 * @model required="true"
	 * @generated
	 */
	int getHeight();

	/**
	 * Sets the value of the '{@link ronmodel.HLNode#getHeight <em>Height</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Height</em>' attribute.
	 * @see #getHeight()
	 * @generated
	 */
	void setHeight(int value);

} // HLNode