/**
 * <copyright>
 * </copyright>
 *
 * $Id: ONNode.java,v 1.3 2007/05/14 09:28:15 choeger Exp $
 */
package ronmodel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>ON Node</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ronmodel.ONNode#getOutgoing <em>Outgoing</em>}</li>
 *   <li>{@link ronmodel.ONNode#getIncoming <em>Incoming</em>}</li>
 *   <li>{@link ronmodel.ONNode#getObjectNet <em>Object Net</em>}</li>
 *   <li>{@link ronmodel.ONNode#getX <em>X</em>}</li>
 *   <li>{@link ronmodel.ONNode#getY <em>Y</em>}</li>
 *   <li>{@link ronmodel.ONNode#getWidth <em>Width</em>}</li>
 *   <li>{@link ronmodel.ONNode#getHeight <em>Height</em>}</li>
 * </ul>
 * </p>
 *
 * @see ronmodel.RonmodelPackage#getONNode()
 * @model abstract="true"
 * @generated
 */
public interface ONNode extends NamedElement {
	/**
	 * Returns the value of the '<em><b>Outgoing</b></em>' reference list.
	 * The list contents are of type {@link ronmodel.ONArc}.
	 * It is bidirectional and its opposite is '{@link ronmodel.ONArc#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Outgoing</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Outgoing</em>' reference list.
	 * @see ronmodel.RonmodelPackage#getONNode_Outgoing()
	 * @see ronmodel.ONArc#getSource
	 * @model type="ronmodel.ONArc" opposite="source"
	 * @generated
	 */
	EList getOutgoing();

	/**
	 * Returns the value of the '<em><b>Incoming</b></em>' reference list.
	 * The list contents are of type {@link ronmodel.ONArc}.
	 * It is bidirectional and its opposite is '{@link ronmodel.ONArc#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Incoming</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Incoming</em>' reference list.
	 * @see ronmodel.RonmodelPackage#getONNode_Incoming()
	 * @see ronmodel.ONArc#getTarget
	 * @model type="ronmodel.ONArc" opposite="target"
	 * @generated
	 */
	EList getIncoming();

	/**
	 * Returns the value of the '<em><b>Object Net</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link ronmodel.ObjectNet#getNodes <em>Nodes</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Object Net</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Object Net</em>' container reference.
	 * @see #setObjectNet(ObjectNet)
	 * @see ronmodel.RonmodelPackage#getONNode_ObjectNet()
	 * @see ronmodel.ObjectNet#getNodes
	 * @model opposite="nodes"
	 * @generated
	 */
	ObjectNet getObjectNet();

	/**
	 * Sets the value of the '{@link ronmodel.ONNode#getObjectNet <em>Object Net</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Object Net</em>' container reference.
	 * @see #getObjectNet()
	 * @generated
	 */
	void setObjectNet(ObjectNet value);

	/**
	 * Returns the value of the '<em><b>X</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>X</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>X</em>' attribute.
	 * @see #setX(int)
	 * @see ronmodel.RonmodelPackage#getONNode_X()
	 * @model required="true"
	 * @generated
	 */
	int getX();

	/**
	 * Sets the value of the '{@link ronmodel.ONNode#getX <em>X</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>X</em>' attribute.
	 * @see #getX()
	 * @generated
	 */
	void setX(int value);

	/**
	 * Returns the value of the '<em><b>Y</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Y</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Y</em>' attribute.
	 * @see #setY(int)
	 * @see ronmodel.RonmodelPackage#getONNode_Y()
	 * @model required="true"
	 * @generated
	 */
	int getY();

	/**
	 * Sets the value of the '{@link ronmodel.ONNode#getY <em>Y</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Y</em>' attribute.
	 * @see #getY()
	 * @generated
	 */
	void setY(int value);

	/**
	 * Returns the value of the '<em><b>Width</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Width</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Width</em>' attribute.
	 * @see #setWidth(int)
	 * @see ronmodel.RonmodelPackage#getONNode_Width()
	 * @model required="true"
	 * @generated
	 */
	int getWidth();

	/**
	 * Sets the value of the '{@link ronmodel.ONNode#getWidth <em>Width</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Width</em>' attribute.
	 * @see #getWidth()
	 * @generated
	 */
	void setWidth(int value);

	/**
	 * Returns the value of the '<em><b>Height</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Height</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Height</em>' attribute.
	 * @see #setHeight(int)
	 * @see ronmodel.RonmodelPackage#getONNode_Height()
	 * @model required="true"
	 * @generated
	 */
	int getHeight();

	/**
	 * Sets the value of the '{@link ronmodel.ONNode#getHeight <em>Height</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Height</em>' attribute.
	 * @see #getHeight()
	 * @generated
	 */
	void setHeight(int value);

} // ONNode