/**
 * <copyright>
 * </copyright>
 *
 * $Id: RonmodelFactoryImpl.java,v 1.2 2007/05/10 19:18:11 talisa Exp $
 */
package ronmodel.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import ronmodel.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class RonmodelFactoryImpl extends EFactoryImpl implements RonmodelFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RonmodelFactory init() {
		try {
			RonmodelFactory theRonmodelFactory = (RonmodelFactory)EPackage.Registry.INSTANCE.getEFactory("http://ronmodel"); 
			if (theRonmodelFactory != null) {
				return theRonmodelFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new RonmodelFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RonmodelFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case RonmodelPackage.RON: return createRON();
			case RonmodelPackage.HL_ARC: return createHLArc();
			case RonmodelPackage.HL_PLACE: return createHLPlace();
			case RonmodelPackage.HL_TRANSITION: return createHLTransition();
			case RonmodelPackage.OBJECT_NET: return createObjectNet();
			case RonmodelPackage.ON_ARC: return createONArc();
			case RonmodelPackage.ON_PLACE: return createONPlace();
			case RonmodelPackage.ON_TRANSITION: return createONTransition();
			case RonmodelPackage.RULE: return createRule();
			case RonmodelPackage.MAPPING: return createMapping();
			case RonmodelPackage.LHS: return createLHS();
			case RonmodelPackage.RHS: return createRHS();
			case RonmodelPackage.NAC: return createNAC();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(final EDataType eDataType, final String initialValue) {
		switch (eDataType.getClassifierID()) {
			case RonmodelPackage.HL_PLACE_TYPE:
				return createHLPlaceTypeFromString(eDataType, initialValue);
			case RonmodelPackage.HL_TRANSITION_KIND:
				return createHLTransitionKindFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(final EDataType eDataType, final Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case RonmodelPackage.HL_PLACE_TYPE:
				return convertHLPlaceTypeToString(eDataType, instanceValue);
			case RonmodelPackage.HL_TRANSITION_KIND:
				return convertHLTransitionKindToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RON createRON() {
		RONImpl ron = new RONImpl();
		return ron;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ObjectNet createObjectNet() {
		ObjectNetImpl objectNet = new ObjectNetImpl();
		return objectNet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Rule createRule() {
		RuleImpl rule = new RuleImpl();
		return rule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Mapping createMapping() {
		MappingImpl mapping = new MappingImpl();
		return mapping;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LHS createLHS() {
		LHSImpl lhs = new LHSImpl();
		return lhs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RHS createRHS() {
		RHSImpl rhs = new RHSImpl();
		return rhs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NAC createNAC() {
		NACImpl nac = new NACImpl();
		return nac;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HLArc createHLArc() {
		HLArcImpl hlArc = new HLArcImpl();
		return hlArc;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HLPlace createHLPlace() {
		HLPlaceImpl hlPlace = new HLPlaceImpl();
		return hlPlace;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HLTransition createHLTransition() {
		HLTransitionImpl hlTransition = new HLTransitionImpl();
		return hlTransition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ONArc createONArc() {
		ONArcImpl onArc = new ONArcImpl();
		return onArc;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ONPlace createONPlace() {
		ONPlaceImpl onPlace = new ONPlaceImpl();
		return onPlace;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ONTransition createONTransition() {
		ONTransitionImpl onTransition = new ONTransitionImpl();
		return onTransition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HLPlaceType createHLPlaceTypeFromString(EDataType eDataType, String initialValue) {
		HLPlaceType result = HLPlaceType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertHLPlaceTypeToString(@SuppressWarnings("unused")
	final EDataType eDataType, final Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HLTransitionKind createHLTransitionKindFromString(EDataType eDataType, String initialValue) {
		HLTransitionKind result = HLTransitionKind.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertHLTransitionKindToString(@SuppressWarnings("unused")
	final EDataType eDataType, final Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RonmodelPackage getRonmodelPackage() {
		return (RonmodelPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static RonmodelPackage getPackage() {
		return RonmodelPackage.eINSTANCE;
	}

} //RonmodelFactoryImpl
