/**
 * <copyright>
 * </copyright>
 *
 * $Id: RonmodelAdapterFactory.java,v 1.2 2007/05/10 19:18:12 talisa Exp $
 */
package ronmodel.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import ronmodel.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see ronmodel.RonmodelPackage
 * @generated
 */
public class RonmodelAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static RonmodelPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RonmodelAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = RonmodelPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(final Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch the delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RonmodelSwitch modelSwitch =
		new RonmodelSwitch() {
			public Object caseRON(RON object) {
				return createRONAdapter();
			}
			public Object caseHLNode(HLNode object) {
				return createHLNodeAdapter();
			}
			public Object caseHLArc(HLArc object) {
				return createHLArcAdapter();
			}
			public Object caseHLPlace(HLPlace object) {
				return createHLPlaceAdapter();
			}
			public Object caseHLTransition(HLTransition object) {
				return createHLTransitionAdapter();
			}
			public Object caseToken(Token object) {
				return createTokenAdapter();
			}
			public Object caseObjectNet(ObjectNet object) {
				return createObjectNetAdapter();
			}
			public Object caseONNode(ONNode object) {
				return createONNodeAdapter();
			}
			public Object caseONArc(ONArc object) {
				return createONArcAdapter();
			}
			public Object caseONPlace(ONPlace object) {
				return createONPlaceAdapter();
			}
			public Object caseONTransition(ONTransition object) {
				return createONTransitionAdapter();
			}
			public Object caseRule(Rule object) {
				return createRuleAdapter();
			}
			public Object caseCodomain(Codomain object) {
				return createCodomainAdapter();
			}
			public Object caseMapping(Mapping object) {
				return createMappingAdapter();
			}
			public Object caseLHS(LHS object) {
				return createLHSAdapter();
			}
			public Object caseRHS(RHS object) {
				return createRHSAdapter();
			}
			public Object caseNAC(NAC object) {
				return createNACAdapter();
			}
			public Object caseNamedElement(NamedElement object) {
				return createNamedElementAdapter();
			}
			public Object defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(final Notifier target) {
		return (Adapter)modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.RON <em>RON</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.RON
	 * @generated
	 */
	public Adapter createRONAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.Token <em>Token</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.Token
	 * @generated
	 */
	public Adapter createTokenAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.ObjectNet <em>Object Net</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.ObjectNet
	 * @generated
	 */
	public Adapter createObjectNetAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.Rule <em>Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.Rule
	 * @generated
	 */
	public Adapter createRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.Codomain <em>Codomain</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.Codomain
	 * @generated
	 */
	public Adapter createCodomainAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.Mapping <em>Mapping</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.Mapping
	 * @generated
	 */
	public Adapter createMappingAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.LHS <em>LHS</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.LHS
	 * @generated
	 */
	public Adapter createLHSAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.RHS <em>RHS</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.RHS
	 * @generated
	 */
	public Adapter createRHSAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.NAC <em>NAC</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.NAC
	 * @generated
	 */
	public Adapter createNACAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.HLNode <em>HL Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.HLNode
	 * @generated
	 */
	public Adapter createHLNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.HLArc <em>HL Arc</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.HLArc
	 * @generated
	 */
	public Adapter createHLArcAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.HLPlace <em>HL Place</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.HLPlace
	 * @generated
	 */
	public Adapter createHLPlaceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.HLTransition <em>HL Transition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.HLTransition
	 * @generated
	 */
	public Adapter createHLTransitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.ONNode <em>ON Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.ONNode
	 * @generated
	 */
	public Adapter createONNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.ONArc <em>ON Arc</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.ONArc
	 * @generated
	 */
	public Adapter createONArcAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.ONPlace <em>ON Place</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.ONPlace
	 * @generated
	 */
	public Adapter createONPlaceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.ONTransition <em>ON Transition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.ONTransition
	 * @generated
	 */
	public Adapter createONTransitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.NamedElement <em>Named Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ronmodel.NamedElement
	 * @generated
	 */
	public Adapter createNamedElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //RonmodelAdapterFactory
